Create a Branch Management Scoping Rule Using the Tooling API
Create a scoping rule that filters account records based on a banker’s branch location. This example uses the branch management data model included in Financial Services Cloud and the RestrictionRule Tooling API object.
| Required Editions |
|---|
| Available in: Lightning Experience in Performance and Unlimited Editions |
| User Permissions Needed | |
|---|---|
| To create and manage scoping rules: | Manage Sharing |
| To view scoping rules: | View Setup & Configuration AND View Restriction and Scoping Rules |
This example uses the SOQL operator in its recordFilter. Check out the Branch Management data model to understand the objects used in this example and how they relate to each other.
-
Use the RestrictionRule object to create and manage both restriction rules and scoping rules. Include the
FullNamevalue and all required fields. For more information, see the reference topic RestrictionRule.In this example, we used these values.
The
userCriteriain this example applies this rule to any active user in your org. Adjust theuserCriteriaif the rule must apply to a different subset of your users.This example also uses objects from the Branch Management data model and sets a scoping rule that shows users lead records related to the user’s current branch location.
To create a similar scoping rule for a different object, adjust the
targetEntityfield to include case, contact, or another supported standard or custom object. -
To create the scoping rule, use a POST request in the tooling API.
POST /services/data/v68.0/tooling/sobjects/RestrictionRule -
Copy your scoping rule definition into the request body.
-
Execute your request. Copy the ID returned for the scoping rule for later reference.
Let’s take a closer look at the Branch Rule On Account example’s SOQL operator.
SOQL(Id, SELECT AccountId FROM BranchUnitCustomer USING SCOPE EVERYTHING WHERE BranchUnitId IN(SELECT CurrentBranchId From Banker WHERE UserOrContactId = $User.Id))- The SOQL statement takes the
Idfrom the account object, which is the target entity whose records the scoping rule filters, and selectsAccountIdfrom theBranchUnitCustomerobject. - The where clause gets the
BranchUnitId, which is a unique identifier of each branch, from a nested query. The nested query finds each banker’s current branch from theBankerobject by matching theUserOrContactIdto the currently logged-in user.
When writing scoping rules using SOQL, follow these guidelines.
- In SOQL operators, the SOQL query object and the scoping rule target entity can’t be the same object. In this example, the SOQL query object is
BranchUnitCustomerand the scoping rule object, called thetargetEntity, isaccount. - In the SOQL type
RecordCriteria, the left operand must query a single ID (primary key) or reference (foreign key) field. In this example, the left operand is a field on the target entity calledId.
For more tips about writing scoping rules using a performant SOQL operator, see Scoping Rules Considerations. The SOQL operator is supported for scoping rules only.
- The SOQL statement takes the
-
Retrieve and Update Information
Use the GET, PATCH, and DELETE methods to retrieve, update, and delete scoping rules.
See Also